> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://reference.flatfile.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://reference.flatfile.com/_mcp/server.

# Detect header

POST https://api.x.flatfile.com/v1/files/detect-header
Content-Type: application/json

Reference: https://reference.flatfile.com/api-reference/files/detect-header

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Body (application/json)

This endpoint expects an object.

- `options` (HeaderDetectionOptions, required)
- `data` (list of list of string, required)

## Response

### 200

- `data` (HeaderDetectionResult, required)

## Errors

### 400 Bad Request Error

- `errors` (list of Error, required)

### 404 Not Found Error

- `errors` (list of Error, required)

## Types

### HeaderDetectionOptions

- `algorithm` (enum, required)
  - Allowed values: `aiDetection`, `default`, `explicitHeaders`, `specificRows`, `dataRowAndSubHeaderDetection`
- `rowsToSearch` (integer, optional)
- `skip` (integer, optional)
- `headers` (list of string, optional)
- `rowNumbers` (list of integer, optional)

### HeaderDetectionResult

- `header` (list of string, required)
- `headerRow` (integer, required)
- `letters` (list of string, required)

### Error

- `message` (string, required)
- `key` (string, optional)

## Examples

**Request**

```json
{
  "options": {
    "algorithm": "aiDetection"
  },
  "data": [
    [
      "",
      "",
      "",
      "",
      ""
    ],
    [
      "Trip Idea",
      "",
      "",
      "",
      ""
    ],
    [
      "Name",
      "Age",
      "City",
      "",
      ""
    ],
    [
      "David",
      "25",
      "New York",
      "Yes",
      ""
    ],
    [
      "Sarah",
      "32",
      "London",
      "",
      "Green"
    ],
    [
      "Michael",
      "42",
      "Sydney",
      "No",
      ""
    ],
    [
      "Jessica",
      "28",
      "Paris",
      "No",
      "Blue"
    ]
  ]
}
```

**Response**

```json
{
  "data": {
    "header": [
      "Name",
      "Age",
      "City",
      "",
      ""
    ],
    "headerRow": 0,
    "letters": [
      "A",
      "B",
      "C"
    ]
  }
}
```

**SDK Code**

```typescript Example0
import { FlatfileClient } from "@flatfile/api";

const client = new FlatfileClient({ token: "YOUR_TOKEN" });
await client.files.detectHeader({
    options: {
        algorithm: "aiDetection"
    },
    data: [["", "", "", "", ""], ["Trip Idea", "", "", "", ""], ["Name", "Age", "City", "", ""], ["David", "25", "New York", "Yes", ""], ["Sarah", "32", "London", "", "Green"], ["Michael", "42", "Sydney", "No", ""], ["Jessica", "28", "Paris", "No", "Blue"]]
});

```

```python Example0
import requests

url = "https://api.x.flatfile.com/v1/files/detect-header"

payload = {
    "options": { "algorithm": "aiDetection" },
    "data": [["", "", "", "", ""], ["Trip Idea", "", "", "", ""], ["Name", "Age", "City", "", ""], ["David", "25", "New York", "Yes", ""], ["Sarah", "32", "London", "", "Green"], ["Michael", "42", "Sydney", "No", ""], ["Jessica", "28", "Paris", "No", "Blue"]]
}
headers = {
    "X-Disable-Hooks": "true",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```go Example0
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.x.flatfile.com/v1/files/detect-header"

	payload := strings.NewReader("{\n  \"options\": {\n    \"algorithm\": \"aiDetection\"\n  },\n  \"data\": [\n    [\n      \"\",\n      \"\",\n      \"\",\n      \"\",\n      \"\"\n    ],\n    [\n      \"Trip Idea\",\n      \"\",\n      \"\",\n      \"\",\n      \"\"\n    ],\n    [\n      \"Name\",\n      \"Age\",\n      \"City\",\n      \"\",\n      \"\"\n    ],\n    [\n      \"David\",\n      \"25\",\n      \"New York\",\n      \"Yes\",\n      \"\"\n    ],\n    [\n      \"Sarah\",\n      \"32\",\n      \"London\",\n      \"\",\n      \"Green\"\n    ],\n    [\n      \"Michael\",\n      \"42\",\n      \"Sydney\",\n      \"No\",\n      \"\"\n    ],\n    [\n      \"Jessica\",\n      \"28\",\n      \"Paris\",\n      \"No\",\n      \"Blue\"\n    ]\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("X-Disable-Hooks", "true")
	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Example0
require 'uri'
require 'net/http'

url = URI("https://api.x.flatfile.com/v1/files/detect-header")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["X-Disable-Hooks"] = 'true'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"options\": {\n    \"algorithm\": \"aiDetection\"\n  },\n  \"data\": [\n    [\n      \"\",\n      \"\",\n      \"\",\n      \"\",\n      \"\"\n    ],\n    [\n      \"Trip Idea\",\n      \"\",\n      \"\",\n      \"\",\n      \"\"\n    ],\n    [\n      \"Name\",\n      \"Age\",\n      \"City\",\n      \"\",\n      \"\"\n    ],\n    [\n      \"David\",\n      \"25\",\n      \"New York\",\n      \"Yes\",\n      \"\"\n    ],\n    [\n      \"Sarah\",\n      \"32\",\n      \"London\",\n      \"\",\n      \"Green\"\n    ],\n    [\n      \"Michael\",\n      \"42\",\n      \"Sydney\",\n      \"No\",\n      \"\"\n    ],\n    [\n      \"Jessica\",\n      \"28\",\n      \"Paris\",\n      \"No\",\n      \"Blue\"\n    ]\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java Example0
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.x.flatfile.com/v1/files/detect-header")
  .header("X-Disable-Hooks", "true")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"options\": {\n    \"algorithm\": \"aiDetection\"\n  },\n  \"data\": [\n    [\n      \"\",\n      \"\",\n      \"\",\n      \"\",\n      \"\"\n    ],\n    [\n      \"Trip Idea\",\n      \"\",\n      \"\",\n      \"\",\n      \"\"\n    ],\n    [\n      \"Name\",\n      \"Age\",\n      \"City\",\n      \"\",\n      \"\"\n    ],\n    [\n      \"David\",\n      \"25\",\n      \"New York\",\n      \"Yes\",\n      \"\"\n    ],\n    [\n      \"Sarah\",\n      \"32\",\n      \"London\",\n      \"\",\n      \"Green\"\n    ],\n    [\n      \"Michael\",\n      \"42\",\n      \"Sydney\",\n      \"No\",\n      \"\"\n    ],\n    [\n      \"Jessica\",\n      \"28\",\n      \"Paris\",\n      \"No\",\n      \"Blue\"\n    ]\n  ]\n}")
  .asString();
```

```php Example0
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.x.flatfile.com/v1/files/detect-header', [
  'body' => '{
  "options": {
    "algorithm": "aiDetection"
  },
  "data": [
    [
      "",
      "",
      "",
      "",
      ""
    ],
    [
      "Trip Idea",
      "",
      "",
      "",
      ""
    ],
    [
      "Name",
      "Age",
      "City",
      "",
      ""
    ],
    [
      "David",
      "25",
      "New York",
      "Yes",
      ""
    ],
    [
      "Sarah",
      "32",
      "London",
      "",
      "Green"
    ],
    [
      "Michael",
      "42",
      "Sydney",
      "No",
      ""
    ],
    [
      "Jessica",
      "28",
      "Paris",
      "No",
      "Blue"
    ]
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
    'X-Disable-Hooks' => 'true',
  ],
]);

echo $response->getBody();
```

```csharp Example0
using RestSharp;

var client = new RestClient("https://api.x.flatfile.com/v1/files/detect-header");
var request = new RestRequest(Method.POST);
request.AddHeader("X-Disable-Hooks", "true");
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"options\": {\n    \"algorithm\": \"aiDetection\"\n  },\n  \"data\": [\n    [\n      \"\",\n      \"\",\n      \"\",\n      \"\",\n      \"\"\n    ],\n    [\n      \"Trip Idea\",\n      \"\",\n      \"\",\n      \"\",\n      \"\"\n    ],\n    [\n      \"Name\",\n      \"Age\",\n      \"City\",\n      \"\",\n      \"\"\n    ],\n    [\n      \"David\",\n      \"25\",\n      \"New York\",\n      \"Yes\",\n      \"\"\n    ],\n    [\n      \"Sarah\",\n      \"32\",\n      \"London\",\n      \"\",\n      \"Green\"\n    ],\n    [\n      \"Michael\",\n      \"42\",\n      \"Sydney\",\n      \"No\",\n      \"\"\n    ],\n    [\n      \"Jessica\",\n      \"28\",\n      \"Paris\",\n      \"No\",\n      \"Blue\"\n    ]\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Example0
import Foundation

let headers = [
  "X-Disable-Hooks": "true",
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "options": ["algorithm": "aiDetection"],
  "data": [["", "", "", "", ""], ["Trip Idea", "", "", "", ""], ["Name", "Age", "City", "", ""], ["David", "25", "New York", "Yes", ""], ["Sarah", "32", "London", "", "Green"], ["Michael", "42", "Sydney", "No", ""], ["Jessica", "28", "Paris", "No", "Blue"]]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.x.flatfile.com/v1/files/detect-header")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```